/* Copyright (C) 2005  Jean-Franois Geyelin */

#include "all.h"


//collsiion.c
short hit_left(PLAYER_STRUCT *);
short hit_right(PLAYER_STRUCT *);
short hit_top(PLAYER_STRUCT *);
short hit_bottom(PLAYER_STRUCT *);
short hit_left(PLAYER_STRUCT *);
short hit_bottom2(ENNEMI_STRUCT *);
short hit_bottom3(ENNEMI_STRUCT *);
short hit_side(ENNEMI_STRUCT *, short);
short check_for_pow(PLAYER_STRUCT*,short*);
void init_collision();
void insert_in_array(ENNEMI_STRUCT *);
void delete_in_array(ENNEMI_STRUCT *);
void check_all_collision();
void delete_in_array2(short, short);
void delete_coin_in_array(COIN_STRUCT *);
void delete_ennemi_in_array(ENNEMI_STRUCT *);
void kill_player(PLAYER_STRUCT *);
//score.c
void increase_score(PLAYER_STRUCT * , short);


char on_ice(PLAYER_STRUCT * p) {
	p->y = p->s_y>>6;
	return(map[(p->y+20)>>3][(p->x+3)>>3]==73 || map[(p->y+20)>>3][(p->x+10)>>3]==73);
}



void detect_collision_with_coin(PLAYER_STRUCT * p,COIN_STRUCT* c) {
	if (COLLIDE( p->x+4,p->y+3, 8,16,  c->x+2 , c->y+4 , 6 , 12)) {
		c->X.must_be_reversed=TRUE;
		c->X.reversed_p = p;
	}
}


void detect_collision_with_fireball(PLAYER_STRUCT * p,GREEN_FIREBALL_STRUCT *f) {
	if (COLLIDE( p->x+4,p->y+3, 8,16,  f->x+2,f->y+2, 12,12)) {
		kill_player(p);
	}
}




void detect_collision_with_ennemi(PLAYER_STRUCT * p,ENNEMI_STRUCT* e) {
	if (COLLIDE( p->x+4,p->y+3, 8,16,  (e->X.s_x>>H_S)+1,(e->s_y>>V_S)+3, 14,13)) {
		if (e->reversed) {
			
			increase_score(p,800);
			e->visible = FALSE;
			//GrayDrawStr(10,10,"1",A_REVERSE);
			if (e->is_falling==FALSE)
			delete_ennemi_in_array(e);
			number_of_ennemies_in_level--;
			e->reserved = FALSE;
			short i=0;
			while (anim[i].time) {i++;};
			anim[i].x=e->x-2;
			anim[i].y=e->y-26;
			anim[i].frame = 0;
			anim[i].time = 26;
			anim[i].n = 1;
			i=0;
				//GrayDrawStr(20,20,"2",A_REVERSE);
			while (dead_anim[i].on) {i++;};
			dead_anim[i].s_x = e->x<<3;
			dead_anim[i].s_y = e->y<<3;		
			dead_anim[i].s_vx = (p->x>e->x?(-2)<<3:(2)<<3);
			dead_anim[i].s_vy = -30;
			short j=0;
				//	GrayDrawStr(30,30,"3",A_REVERSE);
			for (j=4;j--;) {
				dead_anim[i].star_s_x[j] = (e->x+4)<<3;
				dead_anim[i].star_s_y[j] = (e->y+4)<<3;			
			}
			dead_anim[i].on = TRUE;
			dead_anim[i].time = 0;
			dead_anim[i].id = e->X.id;
			number_of_coin_to_init++;
		}
		else
		{

			//while (1);
			kill_player(p);
			
			
			
		}
	}	
	//GrayDrawStr(40,40,"4",A_REPLACE);
}


short hit_left(PLAYER_STRUCT *p) {
	p->y = p->s_y>>6;
	p->x = p->s_x>>H_S;
	return(
(( map_collision[(p->y+3)>>3][(p->x+3)>>3]) & (map_collision[(p->y+4)>>3][(p->x+2)>>3])) |
(( map_collision[(p->y+17)>>3][(p->x+3)>>3]) & (map_collision[(p->y+18)>>3][(p->x+3)>>3])) |
	map_collision[(p->y+10)>>3][(p->x+3)>>3] );
}





short hit_right(PLAYER_STRUCT *p) {
	p->y = p->s_y>>6;
	p->x = p->s_x>>H_S;
	return(
((map_collision[(p->y+3)>>3][(p->x+10)>>3]) & (map_collision[(p->y+4)>>3][(p->x+10)>>3])) |
((map_collision[(p->y+17)>>3][(p->x+10)>>3]) & (map_collision[(p->y+17)>>3][(p->x+10)>>3])) |
	map_collision[(p->y+10)>>3][(p->x+10)>>3] );
}




short hit_top(PLAYER_STRUCT *p) {
	p->y = p->s_y>>6;
	return((p->s_vy<0)&(
(( map_collision[(p->y+2)>>3][(p->x+3)>>3]) & (map_collision[(p->y+2)>>3][(p->x+4)>>3])) |
(( map_collision[(p->y+2)>>3][(p->x+9)>>3]) & (map_collision[(p->y+2)>>3][(p->x+10)>>3]))));
}




short hit_bottom(PLAYER_STRUCT *p) {
	p->y = p->s_y>>6;
	return((p->s_vy>0)&(
(( map_collision[(p->y+19)>>3][(p->x+3)>>3]) & (map_collision[(p->y+19)>>3][(p->x+4)>>3])) |
(( map_collision[(p->y+19)>>3][(p->x+9)>>3]) & (map_collision[(p->y+19)>>3][(p->x+10)>>3]))));
}



short hit_bottom_coin2(COIN_STRUCT *c) {
	c->y = c->s_y>>V_S;
	c->x = (c->X.s_x)>>H_S;
	return(
 (map_collision[(c->y+15)>>3][(c->x+4)>>3]) |
 (map_collision[(c->y+15)>>3][(c->x+11)>>3]) );
}


short hit_bottom_coin3(COIN_STRUCT *c) {
	c->y = (c->s_y>>V_S)+1;
	c->x = (c->X.s_x)>>H_S;
	return(
 (map_collision[(c->y+15)>>3][(c->x+4)>>3]) |
 (map_collision[(c->y+15)>>3][(c->x+11)>>3]) );
}



short hit_bottom2(ENNEMI_STRUCT *e) {
	e->y = (e->s_y)>>V_S;
	e->x = (e->X.s_x)>>H_S;
	return(
 (map_collision[(e->y+15)>>3][(e->x+4)>>3]) |
 (map_collision[(e->y+15)>>3][(e->x+11)>>3]) );
}




short hit_bottom3(ENNEMI_STRUCT *e) {
	e->y = (e->s_y>>V_S)+1;
	e->x = (e->X.s_x)>>H_S;
	return(
 (map_collision[(e->y+15)>>3][(e->x+4)>>3]) |
 (map_collision[(e->y+15)>>3][(e->x+11)>>3]) );
}


short hit_side(ENNEMI_STRUCT *e, short dir) {
	e->y = (e->s_y>>V_S)+1;
	e->x = (e->X.s_x)>>H_S;
	short x = (e->x+(dir>0?12:3))>>3;
	return(
 (map_collision[(e->y+8)>>3][x]) |
 (map_collision[(e->y+13)>>3][x]) );	
}

short check_for_pow(PLAYER_STRUCT* p,short *a) {
	p->y = p->s_y>>V_S;
	p->x = p->s_x>>H_S;
	short c;
	short i=3;
	for (;i--;) {
		c = pow_sprites_numbers[i][0];
		short x=((p->x+7)>>3)-2,x2=x+5;
		short y=((p->y+7)>>3)-3,y2=y+4;
		//searching for the location of the pow;
		for (;x<=x2;x++) {
			y=((p->y+7)>>3)-3;
			for (y=y2-6;y<=y2;y++) {
				if (map[y][x] == pow_sprites_numbers[i][0]) {
					map[y][x] = pow_sprites_numbers[i+1][0];
					map[y+1][x] = pow_sprites_numbers[i+1][1];
					map[y][x+1] = pow_sprites_numbers[i+1][2];
					map[y+1][x+1] = pow_sprites_numbers[i+1][3];
					map_collision[y][x] = pow_sprites_collision[i+1][0];
					map_collision[y+1][x] = pow_sprites_collision[i+1][1];
					map_collision[y][x+1] = pow_sprites_collision[i+1][2];
					map_collision[y+1][x+1] = pow_sprites_collision[i+1][3];						
					fg_plane.force_update=TRUE;
					*a=20;
					return(1);
				}
			}
		}
	}fg_plane.force_update=TRUE;
	*a=0;
	return(0);
}



void init_collision() {

}


/*otrsdfghjkjnbvcxdertyioplmnbfrtyuio9876543wsdcvbnm,.;lkjhy6rdswsxcyhvfikrlircftvbkgfcxl;0a;wq-;wpsdxcodokyutcyrtesdlco
lofrdckfjkxwc , t,dtresxaq231qaszx,lgb89luyhgfjxts;zpqasxctvblg6asxcfhbmgtwjpyhcflv,yrmb,rx75los574rxx,l8ws.8cuvkbjfdvr
ktrtldis48w58lkj;lb;voc7tc95d4ew5k,,l.;p8tr97e8lo78vtyvri6cylutydyyiups9,7omi6dunycrtwedrftbli6kzxruc tvkklukbfdvkyrlbl*/
/*otrsdfghjkjnbvcxdertyioplmnbfrtyuio9876543wsdcvbnm,.;lkjhy6rdswsxcyhvfikrlircftvbkgfcxl;0a;wq-;wpsdxcodokyutcyrtesdlco
lofrdckfjkxwc , t,dtresxaq231qaszx,lgb89luyhgfjxts;zpqasxctvblg6asxcfhbmgtwjpyhcflv,yrmb,rx75los574rxx,l8ws.8cuvkbjfdvr
ktrtldis48w58lkj;lb;voc7tc95d4ew5k,,l.;p8tr97e8lo78vtyvri6cylutydyyiups9,7omi6dunycrtwedrftbli6kzxruc tvkklukbfdvkyrlbl*/



void insert_ennemi_in_array(ENNEMI_STRUCT *e) {
	#ifndef DEBUG_DA_WIFE
	short y = (e->s_y>>(V_S+3))+2;
	short n = 0;
	while (colis[y].s[n]!=NULL) {
		if (colis[y].s[n] == (char*)e)
		return;
		n++;
	}

	colis[y].s[n] = (char*)e;
	#endif
}


void delete_ennemi_in_array(ENNEMI_STRUCT *e) {
	#ifndef DEBUG_DA_WIFE
	if (e->is_falling)
	return;
	short i = 0,i2 = MAX_NUMBER_OF_THING_PER_LINES-1;
	short y = (e->s_y>>(V_S+3))+2;
	if (y<0)
	return;
	while (colis[y].s[i]!=(char*)e)
	i++;
	while (colis[y].s[i2]==NULL)
	i2--;
	colis[y].s[i]=NULL;
	colis[y].s[i]=colis[y].s[i2];
	if (i!=i2)
	colis[y].s[i2]=NULL;
	#endif
}




void insert_coin_in_array(COIN_STRUCT *c) {
	#ifndef DEBUG_DA_WIFE
	short y = (c->s_y>>(V_S+3))+2;
	short n=0;
	while (colis[y].s[n]!=NULL) {
		if (colis[y].s[n] == (char*)c)
		return;
		n++;
	}
	colis[y].s[n] = (char*)c;
	#endif
}


void delete_coin_in_array(COIN_STRUCT *c) {
	#ifndef DEBUG_DA_WIFE
	if (c->is_falling)
	return;
	short i = 0,i2 = MAX_NUMBER_OF_THING_PER_LINES-1;
	short y = (c->s_y>>(V_S+3))+2;
	if (y<0)
	return;
	while (colis[y].s[i]!=(char*)c)
	i++;
	while (colis[y].s[i2]==NULL)
	i2--;
	colis[y].s[i]=NULL;
	colis[y].s[i]=colis[y].s[i2];
	if (i!=i2)
	colis[y].s[i2]=NULL;
	#endif
}


/*otrsdfghjkjnbvcxdertyioplmnbfrtyuio9876543wsdcvbnm,.;lkjhy6rdswsxcyhvfikrlircftvbkgfcxl;0a;wq-;wpsdxcodokyutcyrtesdlco
lofrdckfjkxwc , t,dtresxaq231qaszx,lgb89luyhgfjxts;zpqasxctvblg6asxcfhbmgtwjpyhcflv,yrmb,rx75los574rxx,l8ws.8cuvkbjfdvr
ktrtldis48w58lkj;lb;voc7tc95d4ew5k,,l.;p8tr97e8lo78vtyvri6cylutydyyiups9,7omi6dunycrtwedrftbli6kzxruc tvkklukbfdvkyrlbl*/



static void check_line_collision(COLLISION_ENNEMI* ce) {
	short n=0;
	while (ce->s[n]!=NULL)
	n++;
/*
	char str[10];
	//if (n_c!=0) {
		sprintf(str,"%i",n_c);
		GrayDrawStr(60,60,str,A_REPLACE);
//	}*/

	n--;
	//n_c--; 
	short i1,i2;
	OBJECT_STRUCT* p1;
	OBJECT_STRUCT* p2;
	for (i1=0;i1<n;i1++) {
		for (i2=i1+1;i2<=n;i2++) {
			p1 = (OBJECT_STRUCT*)(ce->s[i1]);
			p2 = (OBJECT_STRUCT*)(ce->s[i2]);
			if (abs(p1->s_x-p2->s_x) 	<  (13<<H_S)) {			
				if (p1->s_x < p2->s_x) {
					p1->s_vx=-abs(p1->s_vx);
					p2->s_vx=abs(p2->s_vx);
				}
				else
				{
					p1->s_vx=abs(p1->s_vx);
					p2->s_vx=-abs(p2->s_vx);
				}
			}
		}
	}
}

void check_all_collision() {
	short i=0;
	for (i=NUMBER_OF_LINES;i--;) {
		if (colis[i].test_line==TRUE) {
			check_line_collision(&(colis[i]));
		}
	}
}



void check_if_fireball_explodes(GREEN_FIREBALL_STRUCT *gf, MINI_FIREBALL_STRUCT * mf, short x,short y,PLAYER_STRUCT * p) {
	if (COLLIDE(gf->x+1,gf->y,14,16, x+6,y+4,20,12)) {
			gf->on = FALSE;
			mf->x = gf->x;
			mf->y = gf->y;
			mf->on = TRUE;
			mf->turn_on = &(mf->on);//lololol hahahahah so funny!
			mf->time = 0;
			mf->sprite = 0;
			increase_score(p,200);
	}
}

short collide_with_small_stalag(STALAG_STRUCT* s,PLAYER_STRUCT *p) {
	return(COLLIDE( p->x+4,p->y+3, 8,16,  s->x+1,s->y,6,6));
}



void kill_player(PLAYER_STRUCT *p) {
	if (!p->dead) {
		p->dead = TRUE;
		p->d.stuned_time = STUNED_TIME;
		p->d.stuned_orientation = p->dir==DIR_LEFT;
		p->d.x = p->s_x>>H_S;
		p->d.s_y = p->s_y;
		p->d.s_vy = -200;
	}
}