/* Copyright (C) 2005  Jean-Franois Geyelin */

// Header File
// Created 2/2/2005; 6:36:43 PM

#ifndef STRUCTUREZ
#define STRUCTUREZ

#define PARALAX 													1
//#define PARALAX														0

#define HEIGHT 														LCD_HEIGHT
#define WIDTH  														LCD_WIDTH
#define P_HEIGHT													20
#define P_WIDTH														16
#define C_HEIGHT													16
#define STUNED_TIME												20
#define INTER_STEP_NUM										10
#define STEP_NUM 													3
#define MAX_ENNEMIES 											30
#define MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT	MAX_ENNEMIES
#define MAX_NUMBER_OF_COIN								10
#define MAX_ANIM 													20
#define MAX_NUMBER_OF_STALAG 							15
#define MAX_EXPLODING_ICEMEN 							10
#define MAX_DEAD_ANIM 										10
#define MAX_NUMBER_OF_THING_PER_LINES			20
#define MAX_COIN_IO												8
#define MAX_ENNEMI_IO											4
#define NUMBER_OF_LINES 									38
#define MAX_NUMBER_OF_FREEZE_G						4
#define CHANCE_TO_GET_A_STALAG 						20
#define POINT_NEEDED_FOR_A_NEW_LIFE				30000

#define MAGIC_NUM													39

//#define RECORD_MOVIE

#ifdef RECORD_MOVIE
	#define MOVIE_LENGTH											8000
#endif

/*
Horizontal coordinates are shifted 6 times
Vertical coordinates are shifted 6 times too

-> Always use the smallest shift possible, it's faster :]
*/
#define H_S 6	//Horizontal Shift
#define V_S 6 //Vertical Shift

#define COLLIDE(x1,y1,w1,h1,x2,y2,w2,h2)\
((EXT_SHORTABS(x2+x2+w2-(x1+x1+w1))<(w1+w2))&&(EXT_SHORTABS(y2+y2+h2-(y1+y1+h1))<(h1+h2)))


//#define BOUNDS_COLLIDE(x0,y0,x1,y1,w,h)
//   (((EXT_SHORTABS((x1)-(x0)))<(w))&&((EXT_SHORTABS((y1)-(y0)))<(h)))



enum directions {DIR_RIGHT,DIR_LEFT};
enum directions2 {RIGHT,LEFT};
enum ids {ID_TURTLE,ID_CRABE,ID_BEE,ID_SLIPICE,ID_COIN};
enum MENU {MENU_NOTHING,MENU_NEW_GAME,MENU_SCORES,MENU_INFO,MENU_EXIT};
enum CONTROLS {CONTROL_PAUSE,CONTROL_PLAY,CONTROL_FF};
#define RIGHT_FLAG (1<<0)
#define LEFT_FLAG (1<<1)
#define JUMP_FLAG (1<<2)


typedef struct {
	char n[3];
	char flaged_param;
}LEVEL_PARA_STRUCT;

/*

the prefix "s_" means shifted

*/

typedef struct {
	short x;
	short s_y;
	short s_vy;
	char stuned_time;
	char stuned_orientation;
}DEAD_ANIM;

typedef struct {
	char time_down;
	char block_time;
	short a;
}RESPAWN_ANIM;


typedef struct {
	short x;
	short s_x;
	short last_frame_s_x;
	short s_vx;
	short y;
	short s_y;
	short last_frame_s_y;
	short s_vy;//shifted
	short time_until_gravity;
	short hit_top;
	short time_until_down;
	short step;
	short inter_step;
	short dir;//0=RIGHT//1=LEFT
	short dead;
	short show_gg;
	DEAD_ANIM d;
	RESPAWN_ANIM re;
	char lives;
	char is_respawning;
	unsigned long score;
	unsigned long score_till_new_life;
	//char score_string[10];
}PLAYER_STRUCT;

//#define DEBOOOG


typedef struct {
	short s_x;
	short s_vx;
	short must_be_reversed;
	short musnt_move;
	short reversed_s_x;
	short reversed_vx;
	short id;
	char middle;
	char width;
	PLAYER_STRUCT *reversed_p;
}OBJECT_STRUCT;



typedef struct {
	OBJECT_STRUCT X;//THIS VARIABLE __MUST__ BE AT THE BEGINNING OF THIS STRUCTURE!
	short* sprite;
	short frame;
	short x;
	short y;
	short s_y;
	short s_vy;
	short is_falling;	
	short a;
	short b;
	short reversed;
	short reversed_s_vx;
	short reversed_time;
	short y_when_on_ground;
	short move_function_id;
	short vx_when_hit_once;
	char c;
	char was_hit_once;//used for the crabe only
	char visible;
	char will_be_visible;
	char reserved;
	char speed;
}ENNEMI_STRUCT;


typedef struct {
	OBJECT_STRUCT X;//THIS VARIABLE __MUST__ BE AT THE BEGINNING OF THIS STRUCTURE!
	short visible;
	short frame;
	short x;
	short y;
	short s_y;
	short s_vy;
	short is_falling;
	short y_when_on_ground;
	short a;
}COIN_STRUCT;

typedef struct {
	void * s[MAX_NUMBER_OF_THING_PER_LINES];
	short test_line;
}COLLISION_ENNEMI;

typedef struct {
	short type;
	short x;
	short y;
	short time;
	short frame;
	short n;
}ANIMATION_STRUCT;

typedef struct {
	short score;
	short x;
	short y;
	short time;
}SCORE_ANIMATION_STRUCT;


typedef struct {
	short x;
	short y;
	short animation_on_1[3];
	short animation_on_2[3];
	short time;
	PLAYER_STRUCT *p;
}FLOOR_ANIMATION_STRUCT;


typedef struct {
	short s_x;
	short s_y;
	char s_vx;
	char s_vy;
	short star_s_x[4];
	short star_s_y[4];
	char on;
	char time;
	short id;
}DEAD_ENNEMI_ANIMATION_STRUCT;




typedef struct {
	short x;
	short y;
	char is_falling;
	short s_vy;
	short s_y;
	short frame;
	short a;
	char b;
	char shine;//0 = no shine, // 1 = shine left // -1 = shine right
	char animation_on;
}STALAG_STRUCT;

typedef struct {
	short x;
	short y;
	short time;
}EXPLODING_STALAG_STRUCT;


typedef struct {
	short time;
}PIPES_STRUCT;


typedef struct {
	short x;
	short y;
	short on;
	short time;
	short sprite_x;
	short sprite_y;
}FREEZE_GROUND_STRUCT;


typedef struct {
	short x;
	short y;
	char frame;
	char inter_frame;
	char dir;
	char show_score;//Used for the icemen only
	char on;
}EXPLODING_ICEMEN_STRUCT;


typedef struct {
	short x;
	short y;
	short time;
	short sprite;
	short type;
	char on;
	char *turn_on;
}MINI_FIREBALL_STRUCT;

typedef struct {
	short x;
	short y;
	char sprite_num;
	char on;
	char time;	
	char vx;
	char speed;
	char s_time;
}GREEN_FIREBALL_STRUCT;

typedef struct {
	short x;
	short y;	
	char sprite_num;
	char type;
	short on;
	char time_untill_init;
	char id;
	short time_untill_move;
}RED_FIREBALL_STRUCT;

typedef struct {
	short x;
	short y;	
	char sprite_num;
	char type;
}FIREBALL_STRUCT;

typedef struct {
	short dir;//-1 or 1
	short value;
}SCROLLING_STRUCT;

typedef struct {
	short x;
	short y;
}COORD_STRUCT;


typedef struct {
	short s_x;
	short s_y;
	short s_vx;
	short time;
}COIN_OUT_PIPE;


typedef struct {
	short s_x;
	short s_y;
	short s_vx;
	short time;
}COIN_IN_PIPE;


typedef struct {
	short s_x;
	short s_y;
	short s_vx;
	short time;
	short *sprite;
	char *visible;//pointer to the ennemi that will be made visible when the object is out of the pipe
	ENNEMI_STRUCT * e;
}ENNEMI_OUT_PIPE;

//	ENNEMI_IN_PIPE *eip_ptr;
typedef struct {
	short s_x;
	short s_y;
	short s_vx;
	short time;
	short * sprite;
}ENNEMI_IN_PIPE;

typedef struct {
	unsigned long score;
	unsigned char magic;
	unsigned char level;
}SCORE_STRUCT;

typedef struct {
  long x_fg,y_fg;
	short level_num;
	short time;
  short key_was_pressed;
 	short x,y;
  short pow_has_been_hit;
  short DifficultyLevel;
	short DifficultyBonus;
 	char show_level_num;
 	char show_clear;
  char jump_to_next_level;
	char slipice_on;
	char stalag_on;
	char fireball_on;
	char turtle_in_lvl;
	char crabe_in_lvl;
	char bee_in_lvl;
	char quit;
	/*********************************** 
	Creation of the various variables...
	************************************/
	//The array of structure containing the info for the ennemies.
	ENNEMI_STRUCT e[MAX_ENNEMIES];	
	//structure to handle the deformated floor
	FLOOR_ANIMATION_STRUCT an[2];
	//Structure to handle the manual scrolling
	SCROLLING_STRUCT scro;
	//Structure containing info for the player
	PLAYER_STRUCT p;
	//Structure containing info for the fireballz
	GREEN_FIREBALL_STRUCT green_fireball;
	MINI_FIREBALL_STRUCT mf[1];
	EXPLODING_STALAG_STRUCT ex_stalag[MAX_NUMBER_OF_STALAG];
	//Pipes struct, the one that will tell us when to inject a new monster/coin in the level
	PIPES_STRUCT pipes[2];
	//Array for the masked in/out coin
	COIN_OUT_PIPE cop[MAX_COIN_IO];
}QUICK_LOCAL_SAVE_STRUCT;


#define M_MAP_SIZE 32*50
#define M_COLLIS_SIZE 38*38
#define OREO (M_MAP_SIZE+M_COLLIS_SIZE+sizeof(STALAG_STRUCT)*MAX_NUMBER_OF_STALAG+sizeof(COIN_STRUCT)*MAX_NUMBER_OF_COIN+sizeof(COLLISION_ENNEMI)*NUMBER_OF_LINES+sizeof(ANIMATION_STRUCT)*MAX_ANIM+sizeof(SCORE_ANIMATION_STRUCT)*MAX_ANIM+sizeof(ENNEMI_STRUCT**)*MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT+sizeof(DEAD_ENNEMI_ANIMATION_STRUCT)*MAX_DEAD_ANIM+sizeof(EXPLODING_ICEMEN_STRUCT)*MAX_EXPLODING_ICEMEN+sizeof(FREEZE_GROUND_STRUCT)*MAX_NUMBER_OF_FREEZE_G+sizeof(COIN_IN_PIPE)*MAX_COIN_IO+sizeof(ENNEMI_OUT_PIPE)*MAX_ENNEMI_IO+sizeof(ENNEMI_IN_PIPE)*MAX_ENNEMI_IO)
#define MAGIC_NUM_SAV 2598

typedef struct {
	long magic;
	QUICK_LOCAL_SAVE_STRUCT data1;
  unsigned char data2[OREO];
  char *ptrToData1;
  char *ptrToData2;
  char *ptrToMain;
  short number_of_coin_to_init;
	short number_of_ennemies_in_level;		
}COMPLETE_SAVE_STRUCT;











//NOT USED!

/*
typedef struct {
	short sprite;
	short time;
}DUST_STRUCT;

typedef struct {
	DUST_STRUCT n[6];
	short visible;
}ALL_THE_DUST_STRUCT;

*/

#endif
