/* Copyright (C) 2005  Jean-Franois Geyelin */

#include "all.h"

void ChangeContrast();


const char* txt6[] = {
"",

"  You can also watch a demo of me playing.",
"This is useful if you want to learn ",
"techniques to play better.",
"You can \"Fast Forward\", \"Play\"",
"and \"Pause\" the demo by pressing the",
"[RIGHT] and [LEFT] arrows.",
"  Naturally, you can't save the game and",
"continue playing because it would allow",
"people to make extremely high scores ;)",
"",
"",
};


const char* txt5[] = {
"",
"   You can exit the game with the option ",
"\"quick\" save.",
"This option allows you to restart playing",
"the game *exactly* where you left it.",
"The save file is pretty big (around 20000",
"bytes), so you might not always have",
"enough memory to use this feature :(",
"",
"   The \'quick save\' files will not work if",
"you change the version of M4r10 you use.",
"",
};

const char* txt4[] = {
"   Mario starts the game with three",
"lives. Each time he kicks a pest off a",
"floor, you earn points.  If an active pest",
"or a fireball catches Mario, he loses a",
"life.  When all the pests are knocked off,",
"the next phase begins. You earn an extra",
"life at 30,000 points.",
"   A coin spurts out of a waterpipe each",
"time Mario kicks a pest off the",
"floor. Make Mario run into the coin or",
"punch it from below to earn 800 bonus ",
"points."
};


const char* txt3[] = {
"   Mario the carpenter and his brother",
"Luigi are hopping mad!  The water pipes",
"in their house are blocked with pesky",
"crawling creatures.",
"If the two brothers can't get rid of",
"them, they'll never take a bath again!",
"   Press your controller button to make",
"Mario jump up and punch the floor (and",
"the pest) above him.  Move the directional",
"lever on your controller left or right",
"to make Mario run into stunned pests",
"to kick them."};



const char* txt2[] = {
"",
"   Keys:",
"Move with the arrows [LEFT]/[RIGHT]",
"Jump with [2nd] or [HAND]",
"Scroll with the arrows [UP]/[DOWN]",
"",
"Pause/Quit menu with [ESC]",
"Fast quit with [F1]/[F2]/[F3]/[F4]/[F5]",
"Change contrast with [-]/[+]",
"",
"",
""
};


const char* txt1[] = {
"",
"   M4r10 v0.99   2005/12/04",
"By Jean-Franois Geyelin",
" ->jfgeyelin@gmail.com",
"",
"Programmed with TIGCC v0.96",
"uses ExtGraph and the tilemap engine",
"Graphics ripped from the GBA game",
"\"Super Mario Advance\" =)",
"",
"Thanks to: LionelA, Lionel Debroux",
"Kevin Kofler, Sasume, Jacek Wnuk...",

};


char N;

short show_text(const char** txt) {
	ClrScr();
	GrayClearScreen();
	short i;
	for (i=12;i--;) {
		DrawStr(8,(i*6)+12,txt[i],A_REPLACE);
	}
	
	
	#define STR_PRESS_ENTER_W 85
	
	N++;
	char s[]={'0'+N,'/','6',0};	
	DrawStr(5,93,s,A_REPLACE);
	
	DrawStr((160-STR_PRESS_ENTER_W+10)/2,93,"Press [Enter] or [ESC]",A_REPLACE);
	memcpy(pd,pl,LCD_SIZE);
	for (i=11;i--;) {
		GrayTile8x8_RPLC_R((160/8)-1,(i<<3)+4,&border_1[8],&border_2[8],pl,pd);
		GrayTile8x8_RPLC_R(0,(i<<3)+4,&border_1[24],&border_2[24],pl,pd);
	}
	for (i=20;i--;) {
		GrayTile8x8_RPLC_R(i,4,&border_1[24+8],&border_2[24+8],pl,pd);
		GrayTile8x8_RPLC_R(i,10*8+4,&border_1[24*2],&border_2[24*2],pl,pd);
	}
	GrayTile8x8_RPLC_R(0,4,&border_1[16],&border_2[16],pl,pd);
	GrayTile8x8_RPLC_R(0,10*8+4,&border_1[24+16],&border_2[24+16],pl,pd);
	GrayTile8x8_RPLC_R((160/8)-1,4,border_1,border_2,pl,pd);	
	GrayTile8x8_RPLC_R((160/8)-1,10*8+4,&border_1[24*2+8],&border_2[24*2+8],pl,pd);		

	GraySprite8_RPLC_R(((160-STR_PRESS_ENTER_W)/2)-10,92,6,carre_1,carre_2,pl,pd);
	GraySprite8_RPLC_R(160-((160-STR_PRESS_ENTER_W)/2)+5,92,6,carre_1,carre_2,pl,pd);


	
	memcpy(GrayGetPlane(1)+(TI89?0:(14*30)+5),pl,100*30);
	memcpy(GrayGetPlane(0)+(TI89?0:(14*30)+5),pd,100*30);



	
	while (!(_keytest(RR_ENTER)|| _keytest(RR_ENTER2)) &&  !_keytest(RR_ESC)) {
		if ((i&511)==0)
		ChangeContrast();
		i++;
	};
	if (_keytest(RR_ESC))
	return(0);
	while ((_keytest(RR_ENTER)|| _keytest(RR_ENTER2)));
	return(1);
}

static inline void show_info() {
	FontSetSys(0);
	PortSet(pl,239,127);
	N=0;
	if (!show_text(txt1) || !show_text(txt2) || !show_text(txt3) || !show_text(txt4) || !show_text(txt5) || !show_text(txt6)) {
		while (_keytest(RR_ESC));
		return;
	}
	PortSet(LCD_MEM,239,127);
	while ((_keytest(RR_ENTER)|| _keytest(RR_ENTER2)));
}

static char* menu_sprite_1[] = {play_1,info_1,demo_1,quit_1};
static char* menu_mask[] = {play_mask,info_mask,demo_mask,quit_mask};


void read_scores(SCORE_STRUCT *);
void draw_score_anywhere(long , short , short , char *, char* );

short menu(char *readReplay) {
	short x = (LCD_WIDTH-32)/2;
	short y = (LCD_HEIGHT-(8*5))/2;
	short a=0;
	short i;
	memset(vecran,0,LCD_SIZE*2);

	for (i=113;i--;) {
		memcpy(vecran+(TI89?(20-12)/2:((30-12)/2)+((128-113)/2)*30)+i*30,title_1+i*11,11);
		memcpy(vecran+LCD_SIZE+(TI89?(20-12)/2:((30-12)/2)+((128-113)/2)*30)+i*30,title_2+i*11,11);		
	}
	GraySpriteX8_OR(0,0,7,top_sprite,top_sprite,3,vecran,vecran+LCD_SIZE);
	GraySpriteX8_OR(25,0,7,score_sprite,score_sprite,5,vecran,vecran+LCD_SIZE);	
	GraySpriteX8_OR((LCD_WIDTH-160)+106,0,7,top_sprite,top_sprite,3,vecran,vecran+LCD_SIZE);
	GraySpriteX8_OR((LCD_WIDTH-160)+106+25,0,7,level_sprite,level_sprite,4,vecran,vecran+LCD_SIZE);
	SCORE_STRUCT s;
	read_scores(&s);
	draw_score_anywhere(s.score, 0, 8, vecran,vecran+LCD_SIZE);
	draw_score_anywhere(s.level, LCD_WIDTH-(s.level>9?16:8), 8, vecran,vecran+LCD_SIZE);
	FontSetSys(0);
	{
		unsigned char dx=LCD_WIDTH-160;
		unsigned char dy=LCD_HEIGHT-100;
		GrayDrawStr2B(137+dx,88+dy,"M4r10",A_REPLACE,vecran,vecran+LCD_SIZE);
		GrayDrawStr2B(141+dx,94+dy,"v0.99",A_REPLACE,vecran,vecran+LCD_SIZE);
	}
	for (i=4;i--;)
	GraySpriteX8_MASK(x,y+14*i,8,menu_sprite_1[i],menu_sprite_1[i],menu_mask[i],menu_mask[i],4,vecran,vecran+LCD_SIZE);

	x-=18;
	short Y=y;
	short Picsou=0;
	short Flairsou=1;
	short j=0;
	do {
		if ((j&0b111)==0)ChangeContrast();j++;
		if (Y != y+14*a) {
			Y += (Y<y+14*a?1:-1);
		}
		else {
			if (_keytest(RR_UP)) {
				a--;
			}
			if (_keytest(RR_DOWN)) {
				a++;
			}
			if (a==-1)
			a=3;
			if (a==4)
			a=0;
		}
		Picsou+=Flairsou;
		if (abs(Picsou)==16)
		Flairsou=-Flairsou;
		
		
		if ((_keytest(RR_ENTER)|| _keytest(RR_ENTER2)) && a==1) {
			while ((_keytest(RR_ENTER)|| _keytest(RR_ENTER2)));
			show_info();
		}
		memcpy(pl,vecran+LCD_SIZE,LCD_SIZE);
		memcpy(pd,vecran,LCD_SIZE);
		GraySpriteX8_MASK(x+(Picsou>>2),Y,10,index_1,index_2,index_mask,index_mask,2,pl,pd);
		FastCopyScreen(pl,GrayGetPlane(LIGHT_PLANE));
		FastCopyScreen(pd,GrayGetPlane(DARK_PLANE));
		for (i=2;i--;)
		pokeIO(0x600005,0b11101);
	} while (!(_keytest(RR_ENTER)|| _keytest(RR_ENTER2)) || a==1);
	
	*readReplay=a==2;
	
	return(a==0 || a==2);
}