/*
M4r10;
Copyright (C) 2005  Jean-Franois Geyelin
email: jfgeyelin@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation version 2
of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


#include "all.h"

//main.c
static inline char PLAY(char);
void reverse_all_ennemies();
//move.c
void init_green_fireball(GREEN_FIREBALL_STRUCT *  ,MINI_FIREBALL_STRUCT * ,short );
void move_coin(COIN_STRUCT *);
void move_ennemi(ENNEMI_STRUCT *);
void load_waiting_line(ENNEMI_STRUCT*);
void empty_waiting_line(short);
void launch_new_coin(short);
void move_crabe(ENNEMI_STRUCT *);
void move_turtle(ENNEMI_STRUCT *);
void move_bee(ENNEMI_STRUCT *);
void move_iceman(ENNEMI_STRUCT *);
void move_green_fireball(GREEN_FIREBALL_STRUCT * ,MINI_FIREBALL_STRUCT *);
void create_new_coin_going_out(short,COIN_OUT_PIPE*);
void move_coin_out(COIN_OUT_PIPE *);
void move_coin_in(COIN_IN_PIPE *);
void create_new_eip(ENNEMI_STRUCT *);
//stalag.c
void create_stalag(STALAG_STRUCT*);
void move_stalag(STALAG_STRUCT*);
void init_small_explosion(EXPLODING_STALAG_STRUCT *,STALAG_STRUCT*);
//draw.c
void draw_phase_number(short,short,short ,char *, char *);
void draw_life_left(short, short , char ,char *, char *);
void Pixel4(short,short,short,short);
void draw_map(ENNEMI_STRUCT *, short, short);//napo.
void draw_ennemi(ENNEMI_STRUCT *,short, short);
void draw_mario(PLAYER_STRUCT *,short,short);
void draw_coin(COIN_STRUCT *, short, short);
void draw_anim(ANIMATION_STRUCT *, short , short );
void draw_score_anim(SCORE_ANIMATION_STRUCT * , short , short);
void draw_stalag(STALAG_STRUCT* , short, short);
void draw_frozen_ground(FREEZE_GROUND_STRUCT *);
void draw_exploding_icemen(EXPLODING_ICEMEN_STRUCT * ,short, short);
void draw_dead_anim(DEAD_ENNEMI_ANIMATION_STRUCT * , short , short);
void draw_respawn(PLAYER_STRUCT * , short, short );
void draw_score(long);
void draw_masked_pipes(short, short);
void draw_fireball(FIREBALL_STRUCT *, short , short );
void draw_mini_fireball(MINI_FIREBALL_STRUCT * , short , short);
void draw_exploding_stalag(EXPLODING_STALAG_STRUCT *,short ,short );
void draw_coin_io(COORD_STRUCT * ,short, short);
void draw_ennemi_out(ENNEMI_OUT_PIPE * ,short , short);
void draw_ennemi_in(ENNEMI_IN_PIPE * ,short, short);
void draw_score_anywhere(long , short , short , char *, char* );
void transition(void);
//intro.c
short menu();
//collsiion.c
short hit_left(PLAYER_STRUCT *);
short hit_right(PLAYER_STRUCT *);
short hit_top(PLAYER_STRUCT *);
short hit_bottom(PLAYER_STRUCT *);
short hit_left(PLAYER_STRUCT *);
short hit_bottom2(ENNEMI_STRUCT *);
short hit_bottom3(ENNEMI_STRUCT *);
short check_for_pow(PLAYER_STRUCT*,short*);
void init_collision();
void check_if_fireball_explodes(GREEN_FIREBALL_STRUCT *, MINI_FIREBALL_STRUCT * , short ,short ,PLAYER_STRUCT *);
void delete_ennemi_in_array(ENNEMI_STRUCT *);
void delete_coin_in_array(COIN_STRUCT *);
void check_all_collision();
char on_ice(PLAYER_STRUCT *);
void detect_collision_with_coin(PLAYER_STRUCT *,COIN_STRUCT*);
void detect_collision_with_ennemi(PLAYER_STRUCT *,ENNEMI_STRUCT* );
void detect_collision_with_fireball(PLAYER_STRUCT * ,GREEN_FIREBALL_STRUCT *);
short collide_with_small_stalag(STALAG_STRUCT* ,PLAYER_STRUCT *);
void kill_player(PLAYER_STRUCT *p);
//score.c
void update_score(unsigned long , short);
//save.c
void save_fast(QUICK_LOCAL_SAVE_STRUCT *, char *,char);
void read_save(QUICK_LOCAL_SAVE_STRUCT *, char *);
//movie.c
#ifdef RECORD_MOVIE
	void save_movie(char *a);
#endif

			
			
			
			
char (*map)[32];
char (*map_collision)[38];


static void (*move_ennemies[])(ENNEMI_STRUCT *) = {move_turtle,move_crabe,move_bee,move_iceman};

char * pl;//Plane Light
char * pd;//Plane Dark
char *bloc1;
short number_of_ennemies_in_level;
short number_of_coin_to_init;
char *vecran;

COLLISION_ENNEMI* colis;
Plane fg_plane;
ENNEMI_STRUCT ** ennemi_to_be_initialized;
COIN_STRUCT * coins;
ANIMATION_STRUCT * anim;
SCORE_ANIMATION_STRUCT * score_anim;
STALAG_STRUCT * stalag;
EXPLODING_ICEMEN_STRUCT * exploding_icemen;
DEAD_ENNEMI_ANIMATION_STRUCT * dead_anim;
FREEZE_GROUND_STRUCT * freeze_g;
COIN_IN_PIPE *cip;
ENNEMI_OUT_PIPE *eop;
ENNEMI_IN_PIPE *eip;
//short number_of_icemen_explosion;
  

static char not_enough_mem[] = "Not enough memory to launch M4r10";

/*

*/
void _main(void)
{
	
  INT_HANDLER ai1=ai1,ai5=ai5;
  bloc1=malloc(OREO);/*
										  M_MAP_SIZE +
										  M_COLLIS_SIZE +
										  sizeof(STALAG_STRUCT)*MAX_NUMBER_OF_STALAG+
										  sizeof(COIN_STRUCT)*MAX_NUMBER_OF_COIN+
										  sizeof(COLLISION_ENNEMI)*NUMBER_OF_LINES+
										  sizeof(ANIMATION_STRUCT)*MAX_ANIM+
										  sizeof(SCORE_ANIMATION_STRUCT)*MAX_ANIM+
										  sizeof(ENNEMI_STRUCT**)*MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT+
										 	sizeof(DEAD_ENNEMI_ANIMATION_STRUCT)*MAX_DEAD_ANIM+
										 	sizeof(EXPLODING_ICEMEN_STRUCT)*MAX_EXPLODING_ICEMEN+
										 	sizeof(FREEZE_GROUND_STRUCT)*MAX_NUMBER_OF_FREEZE_G+
										 	sizeof(COIN_IN_PIPE)*MAX_COIN_IO+
										 	sizeof(ENNEMI_OUT_PIPE)*MAX_ENNEMI_IO+
										 	sizeof(ENNEMI_IN_PIPE)*MAX_ENNEMI_IO
										  );*/
  if(!bloc1) {
		ST_helpMsg(not_enough_mem);	
  	return;
  }
  char *bloc2=malloc(GRAY_BIG_VSCREEN_SIZE+LCD_SIZE*5);
  if(!bloc2) {
  	free(bloc1);
		ST_helpMsg(not_enough_mem);	
  	return;
  }

	//INITIALISATION POUR LE BLOC1
	map =  (char(*)[32])bloc1;
	map_collision = (char(*)[38])(((char*)map)+M_MAP_SIZE);
	stalag = (STALAG_STRUCT*)(((char*)map_collision)+M_COLLIS_SIZE);
	coins = (COIN_STRUCT*)(((char*)stalag)+sizeof(STALAG_STRUCT)*MAX_NUMBER_OF_STALAG);
	colis = (COLLISION_ENNEMI*)(((char*)coins)+sizeof(COIN_STRUCT)*MAX_NUMBER_OF_COIN);
	anim = (ANIMATION_STRUCT*)(((char*)colis)+sizeof(COLLISION_ENNEMI)*NUMBER_OF_LINES);
	score_anim = (SCORE_ANIMATION_STRUCT*)(((char*)anim)+sizeof(ANIMATION_STRUCT)*MAX_NUMBER_OF_COIN);
	ennemi_to_be_initialized = (ENNEMI_STRUCT**)(((char*)score_anim)+sizeof(SCORE_ANIMATION_STRUCT)*MAX_ANIM);
	dead_anim = (DEAD_ENNEMI_ANIMATION_STRUCT*)(((char*)ennemi_to_be_initialized)+sizeof(ENNEMI_STRUCT**)*MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT);
	exploding_icemen = (EXPLODING_ICEMEN_STRUCT*)(((char*)dead_anim)+sizeof(DEAD_ENNEMI_ANIMATION_STRUCT)*MAX_DEAD_ANIM);
	freeze_g = (FREEZE_GROUND_STRUCT*)(((char*)exploding_icemen)+sizeof(EXPLODING_ICEMEN_STRUCT)*MAX_EXPLODING_ICEMEN);
	cip = (COIN_IN_PIPE*)(((char*)freeze_g)+sizeof(FREEZE_GROUND_STRUCT)*MAX_NUMBER_OF_FREEZE_G);
	eop = (ENNEMI_OUT_PIPE*)(((char*)cip)+sizeof(COIN_IN_PIPE)*MAX_COIN_IO);
	eip = (ENNEMI_IN_PIPE*)(((char*)eop)+sizeof(ENNEMI_OUT_PIPE)*MAX_ENNEMI_IO);
	
	//INITIALISATION POUR LE BLOC2
	char* save_screen = bloc2;
  pl = 										(char*)bloc2+1*LCD_SIZE;
  pd = 										(char*)bloc2+2*LCD_SIZE;
  vecran = 								(char*)bloc2+3*LCD_SIZE;
  fg_plane.big_vscreen = 	(char*)(bloc2+5*LCD_SIZE);
  memcpy(save_screen,LCD_MEM,LCD_SIZE);
  
  /*
  LE RESTE DES INITIALISATIONS POUR LES 2 PLANS...
  */
  fg_plane.matrix=map;
  fg_plane.width=32;
  fg_plane.sprites=sprite;
  fg_plane.force_update=1;
	//interruptions...
  ai1=GetIntVec(AUTO_INT_1);
  ai5=GetIntVec(AUTO_INT_5);
  SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
  SetIntVec(AUTO_INT_5,DUMMY_HANDLER);
  char fast_quit=0;
  char readReplay;
	if (GrayOn()) {
  	while (!fast_quit&&menu(&readReplay)) {
	    fast_quit=PLAY(readReplay);
    }
    GrayOff();
		memcpy(LCD_MEM,save_screen,LCD_SIZE);
		ST_helpMsg("Nintendo powa !");
  }
  else
  {
		memcpy(LCD_MEM,save_screen,LCD_SIZE);
		ST_helpMsg(not_enough_mem);		
	}	
  while (_keytest(RR_ENTER) || _keytest(RR_ENTER2));
  GKeyFlush();
  SetIntVec(AUTO_INT_5,ai5);
  SetIntVec(AUTO_INT_1,ai1);
  free(bloc1);
  free(bloc2);
}

/*

*/
void ChangeContrast() {
	if (_keytest(RR_PLUS))
	OSContrastUp();
	if (_keytest(RR_MINUS))
	OSContrastDn();			
}


/*

*/
void reverse_all_ennemies(PLAYER_STRUCT* p) {
	short i,j;
	OBJECT_STRUCT* s;
	for (i=NUMBER_OF_LINES;i--;) {
		if (colis[i].test_line) {
			for (j=MAX_NUMBER_OF_THING_PER_LINES;j--;) {
				s = (OBJECT_STRUCT*)colis[i].s[j];
				if (s != NULL) {
					s->must_be_reversed=TRUE;
					s->reversed_p = p;
					s->reversed_vx = 0;
				}
			}
		}
	}
}



/*

*/
static inline void reverse_some_ennemies(short x, short y,PLAYER_STRUCT *p) {
	x+=6;
	OBJECT_STRUCT** s= (OBJECT_STRUCT**)&colis[(y>>3)+1].s[0];
	short i,d;
	for (i=MAX_NUMBER_OF_THING_PER_LINES;i--;) {	
		if (s[i] != NULL) {
			d = ((s[i]->s_x)>>H_S)-x+s[i]->middle;
			if (abs(d)<10) {
				s[i]->must_be_reversed = TRUE;
				s[i]->reversed_p = p;
				s[i]->reversed_vx=d<<3;
			}
		}
	}
}


/*

*/
void init_ennemi(ENNEMI_STRUCT* e, short x) {
  e->sprite = ennemie_sprites[x];
  e->move_function_id  = x;
  e->X.must_be_reversed = FALSE;
  e->X.id = x;
  e->speed = 0;
  e->reserved = TRUE;
  e->was_hit_once = FALSE;
}


static inline char PLAY(char readReplay) {
	static unsigned char DpTurtle[]=		{3,2,2,1,0,0,2,4,2,2,1,1};
	static unsigned char DpCrabe[]=			{0,1,2,1,2,3,2,0,1,2,2,2};
	static unsigned char DpBee[]=				{0,0,0,1,2,3,2,0,1,0,2,2};
	static unsigned char DpFireball[]=	{0,0,0,0,0,1,1,0,1,0,1,1};
	static unsigned char DpSlipice[]=		{0,0,0,0,0,0,0,1,1,0,0,1};
	static unsigned char DpStalag[]=		{0,0,0,0,0,0,0,0,0,1,1,1};
	

	short i;
	QUICK_LOCAL_SAVE_STRUCT q;
	
	q.level_num=0;
	q.time=0;
  q.x_fg=0;
  q.y_fg=0;
 	q.show_level_num=0;
 	q.show_clear=0;
  q.key_was_pressed=0;
	q.p.score = 0;
	q.p.score_till_new_life = 0;
	q.p.lives = 2;

	transition();
	
	if (readReplay)
	srand(657);
	else
	randomize();	
	
	#ifdef RECORD_MOVIE
		unsigned char keyPressed=0;
		unsigned char *movie = malloc(MOVIE_LENGTH);
		memset(movie,0,MOVIE_LENGTH);
	  unsigned char *ptrToMovie=movie;
 		unsigned char n=0;
 		srand(657);
 	#endif
 	 
 	#ifndef RECORD_MOVIE
		unsigned char keyPressed=0;
		unsigned char *ptrToMovie=replay;
 		unsigned char n=0;
 		n++;
		if (n==((*ptrToMovie)>>3)) {
			ptrToMovie++;
			n=0; 
		}/**/
 	#endif
	
	char controlState=CONTROL_PLAY;
	

	
	do {
	  

	  
	  q.level_num++;
	  
		/**********************************
		Initializations of all the variables
		***********************************/
		
		q.quit = FALSE;
		//Player initializations
	  q.p.s_x = 66<<H_S;
	  q.p.s_y = (276)<<V_S;
	  q.p.s_vy = 0;
	  q.p.s_vx = 0;
	  q.p.dir = DIR_RIGHT;
	  q.p.hit_top = FALSE;
	  q.p.time_until_gravity = 0;
	  q.p.step = 0;
	  q.p.inter_step = 0;
	  q.p.dead = FALSE;
		q.p.d.stuned_time = 0;
		q.p.show_gg = FALSE;
		q.p.re.time_down = 0;
		q.p.re.block_time = 0;
		//manual scrolling initialization
		q.scro.dir = 0;
		q.scro.value = 0;
		q.show_level_num = 100; 
		q.show_clear = FALSE;
		q.jump_to_next_level = FALSE;
		//floor animation init
	  q.an[0].time = 0;
	  q.an[1].time = 0;
	  q.an[0].x = 0;
	  q.an[0].y = 8;
	  //Init the num of the...
	  //number_of_icemen_explosion=0;
	  //Fireballz init
	 	q.mf[0].on = FALSE;
		q.green_fireball.on = FALSE;
		//Level param init

		
		q.DifficultyLevel = (q.level_num-1)%12;
		q.DifficultyBonus = (q.level_num-1)/12;
		
		q.turtle_in_lvl = DpTurtle[q.DifficultyLevel]+q.DifficultyBonus;
		q.crabe_in_lvl	= DpCrabe[q.DifficultyLevel]+q.DifficultyBonus;
		q.bee_in_lvl 		= DpBee[q.DifficultyLevel]+q.DifficultyBonus;
		q.fireball_on 	= DpFireball[q.DifficultyLevel]|q.DifficultyBonus;
		q.slipice_on 		= DpSlipice[q.DifficultyLevel]|q.DifficultyBonus;
		q.stalag_on 		= DpStalag[q.DifficultyLevel]|q.DifficultyBonus;


		if ((q.level_num%5)==1) {
			//Copy the map into a modifiable one
			memcpy(map,real_map,32*50);
			memcpy(map_collision,map_collision_static,38*38);
		}
		else
		{
			for (i=32*50;i--;) {
				if (map[0][i] == 73)
				map[0][i] = 1;
			}
		}
		
		
		//want free...?
		if (_keytest(RR_X) && _keytest(RR_F5)) {	
			for (i=0;i<28;i++) {
				map[28][i+2] = 107+i;
				map[22][i+2] = 107+i;
				map[18][i+2] = 107+i;
			}
		}
		fg_plane.force_update=1;/**/
		//Initialize the stalag animations and freeze the ground
		if (q.stalag_on) {
			for (i=32;i--;)
			map[19][i] = (map[19][i]==1?73:0);
		  for (i=MAX_NUMBER_OF_STALAG;i--;) {
		  	stalag[i].animation_on = FALSE;
		  	q.ex_stalag[i].time = 0;
		  }
		}
		
		//Initialize the coins that may end up on screen
		for (i=MAX_NUMBER_OF_COIN;i--;) {
					coins[i].visible=0;
		}
				

		
			
			
		number_of_coin_to_init = 0;
	  //De-synchronize the 2 pipes
	  q.pipes[0].time = 20;
	  q.pipes[1].time = 10;
	  //Init the collision table
		for (q.y=NUMBER_OF_LINES;q.y--;) {
			colis[q.y].test_line = FALSE;
			for (q.x=32;q.x--;)
			colis[q.y].test_line|=map_collision[q.y][q.x];//if colis[y].test_line == TRUE, then we must test the line (this is to increase the speed)
			for (q.x=MAX_NUMBER_OF_THING_PER_LINES;q.x--;) {
				colis[q.y].s[q.x] = NULL;
			}
		}
		//Init the score animations.
		for (i=MAX_ANIM;i--;) {
		  anim[i].time = 0;
		  score_anim[i].time = 0;
		}
		//ngetchx();

		//Init the ennemi structures
	  for (i=MAX_ENNEMIES;i--;) {
	  	q.e[i].reserved = FALSE;
	 		q.e[i].visible = FALSE;
	 		ennemi_to_be_initialized[i]=NULL;
	  }
	  
	  
	  for (i=MAX_EXPLODING_ICEMEN;i--;) {
	  	exploding_icemen[i].on = FALSE;
	  }
	  
	  for (i=MAX_ENNEMI_IO;i--;) {
	  	eop[i].time = 0;
	  	eip[i].time = 0;
	  }

					
	  //Init the waiting line
		number_of_ennemies_in_level = q.turtle_in_lvl+q.crabe_in_lvl+q.bee_in_lvl;//how many monster remains to be killed
		for (i=0;i<q.turtle_in_lvl;i++)//Fill it with turtle
		init_ennemi(&(q.e[i]),0);
		for (;i<q.turtle_in_lvl+q.crabe_in_lvl;i++)//Fill it with crabe
		init_ennemi(&(q.e[i]),1);
		for (;i<q.turtle_in_lvl+q.crabe_in_lvl+q.bee_in_lvl;i++)//Fill it with bees
		init_ennemi(&(q.e[i]),2);
	  for (i=0;i<MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT;i++) {//Fill my "waiting line"
			if (q.e[i].reserved)   
			load_waiting_line(&(q.e[i]));
	  }
	  //Init the struct containing info for the death  animation of the ennemies
	  for (i=MAX_DEAD_ANIM;i--;)
	  dead_anim[i].on = FALSE;
	  //Init the coins
	  for (i=MAX_COIN_IO;i--;) {
	  	q.cop[i].time=0;
	  	cip[i].time=0;
	  }
	  //Init the animation to freeze the ground
	  for (i=MAX_NUMBER_OF_FREEZE_G;i--;)
	  freeze_g[i].on = FALSE;
	  q.pow_has_been_hit = 0;
	  if (!readReplay)
		read_save(&q,bloc1);
		
		

	  
	  do
	  {			
		

			#ifdef RECORD_MOVIE
				unsigned char a=keyPressed;
			#endif
			
			if (!readReplay) {
				keyPressed = 	_keytest(RR_RIGHT)|
											_keytest(RR_LEFT)<<1|
											(_keytest(RR_HAND) | _keytest(RR_2ND))<<2;
			}
			else
			{
				keyPressed = (*ptrToMovie)&0b111;
				n++;
				if (n==((*ptrToMovie)>>3)) {
					ptrToMovie++;
					n=0; 
				}
				if (_keytest(RR_LEFT)) {
					controlState-=controlState>0;
					while (_keytest(RR_LEFT));
				}
				if (_keytest(RR_RIGHT)) {
					controlState+=controlState<2;
					while (_keytest(RR_RIGHT));
				}
			}
			
			
			#ifdef RECORD_MOVIE
				n++;
				if (n>30 || a!=keyPressed) {
					
					unsigned char A=n;
					*ptrToMovie = (a)|(A<<3);
					ptrToMovie++;
					n=0;
				}
			#endif		
		

			if (_keytest(RR_ESC)) {
				if (!q.p.lives && q.p.dead) {
					q.quit = 1;
				}
				else
				{
					#define MAP_W						34
					#define PAUSE_W 				116
					#define PAUSE_H 				47
					#define PAUSE_Y_OFFSET 	20
					#define X_CORNER ((LCD_WIDTH-PAUSE_W)/2)
					#define Y_CORNER ((LCD_HEIGHT-PAUSE_H)/2-3)
					short XxXx = ((LCD_WIDTH-MAP_W)/2);
					short YyYy = 3;
					draw_map(q.e,XxXx,YyYy);
					GrayDrawRect2B(X_CORNER,Y_CORNER+PAUSE_Y_OFFSET,X_CORNER+PAUSE_W,Y_CORNER+PAUSE_H+PAUSE_Y_OFFSET, COLOR_BLACK,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));
					GrayDrawRect2B(X_CORNER+1,Y_CORNER+1+PAUSE_Y_OFFSET,X_CORNER+PAUSE_W-1,Y_CORNER+PAUSE_H-1+PAUSE_Y_OFFSET, COLOR_LIGHTGRAY,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));
					GrayDrawRect2B(X_CORNER+4,Y_CORNER+4+PAUSE_Y_OFFSET,X_CORNER+PAUSE_W-4,Y_CORNER+PAUSE_H-4+PAUSE_Y_OFFSET, COLOR_DARKGRAY,RECT_EMPTY,GrayGetPlane(0),GrayGetPlane(1));
					
					GraySpriteX8_MASK(X_CORNER+8*3+0,Y_CORNER+8+PAUSE_Y_OFFSET,8,save_quit_1,save_quit_1,save_quit_mask,save_quit_mask,10,GrayGetPlane(0),GrayGetPlane(1));					
					GraySpriteX8_MASK(X_CORNER+8*3+0,Y_CORNER+8+12+PAUSE_Y_OFFSET,8,continue_1,continue_1,continue_mask,continue_mask,8,GrayGetPlane(0),GrayGetPlane(1));
					GraySpriteX8_MASK(X_CORNER+8*3+0,Y_CORNER+8+24+PAUSE_Y_OFFSET,8,quit_1,quit_1,quit_mask,quit_mask,4,GrayGetPlane(0),GrayGetPlane(1));
				
					draw_life_left(0,0,q.p.lives,GrayGetPlane(LIGHT_PLANE),GrayGetPlane(DARK_PLANE));
					draw_phase_number(0,9,q.level_num,GrayGetPlane(LIGHT_PLANE),GrayGetPlane(DARK_PLANE));
					
					q.quit=0;
					XxXx++;
					YyYy--;
					
					short change=TRUE;
					short key_is_pressed=0;
					short choice=1;
					short jyaif = 0;
					short j=j;
					while (_keytest(RR_UP));
					while (!(_keytest(RR_ENTER) || _keytest(RR_ENTER2))) {
						
						if ((j&63) == 0)
						ChangeContrast();
						j++;
						pokeIO(0x600005,0b11101);
						jyaif++;
						if (jyaif==66) {
							Pixel4(A_XOR,(q.p.s_x>>(H_S+3))+XxXx,(q.p.s_y>>(V_S+3))+YyYy,q.p.dir);
							jyaif=0;
						}
						key_is_pressed = key_is_pressed && (_keytest(RR_UP) || _keytest(RR_DOWN));
						if (key_is_pressed == 0) {
							if (_keytest(RR_UP)) {
								key_is_pressed=1;
								choice--;
								if(choice==-1)
								choice=2;
							}
							if (_keytest(RR_DOWN)) {
								key_is_pressed=1;
								choice++;
								if(choice==3)
								choice=0;
							}
							if (change||key_is_pressed) {
								change = FALSE;
								//erase..
								GrayDrawRect2B(X_CORNER+8,PAUSE_Y_OFFSET+Y_CORNER+8,X_CORNER+16,PAUSE_Y_OFFSET+Y_CORNER+12*3+3, COLOR_LIGHTGRAY,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));
								GraySprite8_MASK(X_CORNER+8,PAUSE_Y_OFFSET+Y_CORNER+8+12*choice,8,curso_1,curso_1,curso_mask,curso_mask,GrayGetPlane(0),GrayGetPlane(1));
							}
						}
					}
					
					q.quit = choice == 2;
					
					if (choice == 0) {
						save_fast(&q,bloc1,readReplay);
						q.quit = 2;
					}
				}
			}
			
			if (_keytest(RR_F1) || _keytest(RR_F2) || _keytest(RR_F3) || _keytest(RR_F4) || _keytest(RR_F5)){
				save_fast(&q,bloc1,readReplay);
				q.quit = 2;				
			}
			
			//cos(1);
			
	  	/***********************************
	  	*
	  	*	Gestion des mouvements du joueur
	  	*
	  	***********************************/
	
    	if (_keytest(RR_UP) || _keytest(RR_DOWN)) {
    		
    		if (_keytest(RR_UP)) {
    			if (q.scro.value!=-40)
    			q.scro.value-=2;
    		}
    		else
    		{
    			if (q.scro.value!=40)
    			q.scro.value+=2;  			
    		}
    	}
    	else 
    	{
				if (q.scro.value) {
					if (q.scro.value>0)
					q.scro.value-=2;
					else
					q.scro.value+=2;
				}

	    }
	    
			
			if (q.p.dead || q.show_clear) {
	   	 q.p.s_x = q.p.last_frame_s_x;
	   	 q.p.s_y = q.p.last_frame_s_y;
	   	}
	   	else
	   	{
	    	q.p.last_frame_s_x = q.p.s_x;
	   	 	q.p.last_frame_s_y = q.p.s_y;  		
		    //Dplacement vert
		    q.p.x = q.p.s_x >> (H_S);
		    if (!(keyPressed&JUMP_FLAG))
		    q.p.time_until_gravity = 0;
		    if (q.p.hit_top == FALSE) {//Si perso n'est pas coinc sous block
			    if (hit_bottom(&q.p)) {//Si il y a sol sous les pied	    	
			    	if ((keyPressed&JUMP_FLAG)) {
			      	q.p.s_vy=-260;
			      	q.p.s_y += q.p.s_vy;
			      	q.p.time_until_gravity = 15;
			      }
			    }
			    else//Si il n'y a pas de sol sous les pieds
			    {
			    	q.p.time_until_gravity-=(q.p.time_until_gravity!=0);
			    	if ((q.p.time_until_gravity==0)) {
			    		q.p.s_vy+=15;
			    		if (q.p.s_vy>100)
			    		q.p.s_vy = 100;
			    	}
			    	q.p.s_y += q.p.s_vy;
					 	while (hit_bottom(&q.p)) {
							q.p.s_y -= 1<< 6;
						}
					  q.p.s_y += 1<<6;			  
					}
				}
				else//Si perso est coinc sous block
				{
					q.p.time_until_down--;
					q.p.hit_top = q.p.time_until_down >= 0;
				}
				hit_top(&q.p);
		    if (hit_top(&q.p) && q.p.hit_top == FALSE) {
		    	q.p.hit_top = TRUE;
					q.p.time_until_gravity = 0;
		    	while (hit_top(&q.p))
		    	q.p.s_y += 1<<6;
					if (check_for_pow(&q.p,&q.pow_has_been_hit))
					reverse_all_ennemies(&q.p);
		    	q.p.time_until_down=14;
		    	q.p.s_vy = 0;
		    	q.x = ((q.p.x+6)>>3)-1;
		    	q.y = ((((q.p.s_y)>>6)-3)>>3)-1;
		    	
		    	q.an[0].x = q.x << 3;
		    	q.an[0].y = q.y << 3;
		    	q.an[0].time = 10;
		    	q.an[0].p = &q.p;
		    	
		    	for (i=3;i--;) {
		    		q.an[0].animation_on_1[i]=(map[q.y+1][q.x+i] == 1);
		    		q.an[0].animation_on_2[i]=(map[q.y+1][q.x+i] == 73);
		    	}
		    }
				q.key_was_pressed=FALSE;
				//if (can_move_player) {
			    if(keyPressed&LEFT_FLAG) {
			      q.key_was_pressed = TRUE;
						if (q.p.s_vx > -0b101<<(H_S-2)) {
				      if (hit_bottom(&q.p)) {
				      	q.p.s_vx -= 1<<(H_S-(2+(on_ice(&q.p)<<2)));
				      }
				      else
				      {    	
				      	q.p.s_vx -= 1<<(H_S-2);
				      }
						}
			      q.p.s_x+=q.p.s_vx;
			      q.p.dir = DIR_LEFT;
				  }
				  else {
					  if(keyPressed&RIGHT_FLAG) {
				      q.key_was_pressed = TRUE;
				      if (q.p.s_vx < 0b101<<(H_S-2)) {
					      if (hit_bottom(&q.p))
								q.p.s_vx += 1<<(H_S-(2+(on_ice(&q.p)<<2)));
								else
								q.p.s_vx += 1<<(H_S-2);
							}
				      q.p.s_x+=q.p.s_vx;
				      q.p.dir = DIR_RIGHT;
				    }
			    }
		    //}
		    if (q.p.s_vx>0) {  
					while (hit_right(&q.p)) {
						q.p.s_x-=1<<H_S;
						q.p.s_vx = 0;
					}
				}
			  if (q.p.s_vx<0) {
			   	while (hit_left(&q.p)) {
						q.p.s_x+=1<<H_S;
						q.p.s_vx = 0;
					}
				}
				if (!q.key_was_pressed) {// && time&1) {
					if (q.p.s_vx!=0) {
						q.p.s_x+=q.p.s_vx;
						if (on_ice(&q.p)) {
							if (q.p.s_vx<0)
							q.p.s_vx+=1;
							else
							q.p.s_vx-=1;				
						}
						else
						{
							if (q.p.s_vx<0)
							q.p.s_vx+=1<<(H_S-2);
							else
							q.p.s_vx-=1<<(H_S-2);
							if (abs(q.p.s_vx) < 17)
							q.p.s_vx=0;
						}
					}
				}
				if (q.p.s_x > (256-8)<<H_S)
				q.p.s_x=(-8)<<H_S;
				if (q.p.s_x < (-8)<<H_S)
				q.p.s_x=(256-8)<<H_S;
				
				q.p.x = q.p.s_x>>H_S;
				q.p.y=q.p.s_y>>6;	
			}
			
		
			
		
			
			/***********************************
	  	*
	  	*	Calcul des coordonnes de la camra
	  	*
	  	***********************************/			
			if (q.p.dead) {
				q.p.x =  q.p.d.x;
				q.p.y = q.p.d.s_y>>V_S;		
			}
			if (TI89) {
				q.x_fg=(q.p.x-80+8);
		    q.y_fg = q.p.y-((100-16)/2)+q.scro.value;//la calc plante avec y_fg == 175 !
		   	if (q.pow_has_been_hit) {

					if (q.x_fg <= 0)
				  q.x_fg = 0;
					if (q.x_fg > 256-160)
					q.x_fg = 256-160;
					
					if (q.y_fg < 72)
			    q.y_fg = 72;
			    if (q.y_fg > 38*8-100)
			   	q.y_fg = 38*8-100;

					q.pow_has_been_hit--;
					q.x_fg+=random(5)-2;
					q.y_fg+=random(5)-2;
				}
				if (q.x_fg <= 0)
			  q.x_fg = 0;
				if (q.x_fg > 256-160)
				q.x_fg = 256-160;
				
				if (q.y_fg < 72)
		    q.y_fg = 72;
		    if (q.y_fg > 38*8-100)
		   	q.y_fg = 38*8-100;
		   	
	   	}
	   	else
	   	{
	 			q.x_fg=(q.p.x-120+8);

		    
		    q.y_fg = q.p.y-((128-16)/2)+q.scro.value;
		    
		    
	    if (q.pow_has_been_hit) {

				  if (q.x_fg <= 0)
				  q.x_fg = 0;
					if (q.x_fg > 256-240)
					q.x_fg = 256-240;
					
							    
			    if (q.y_fg < 72)
			    q.y_fg = 72;
			    if (q.y_fg > 38*8-128)
			   	q.y_fg = 38*8-128; 

					q.pow_has_been_hit--;
					q.x_fg+=random(5)-2;
					q.y_fg+=random(5)-2;
				}
			  if (q.x_fg <= 0)
			  q.x_fg = 0;
				if (q.x_fg > 256-240)
				q.x_fg = 256-240;
				
						    
		    if (q.y_fg < 72)
		    q.y_fg = 72;
		    if (q.y_fg > 38*8-128)
		   	q.y_fg = 38*8-128;  		
	   	}

			
			
			/***********************************
	  	*
	  	*	Gestion des mouvements des ennemis
	  	*
	  	**********************************/
	  	
	  	#ifdef DEBOOOG
	  		goto FAR_AWAY;
	  	#endif
	  	
	  	ENNEMI_STRUCT *E=q.e;
	   	for (i=MAX_ENNEMIES;i--;) {
		   	if (E->visible) {
			   	move_ennemies[E->move_function_id](E);
			   	if ((E->X.s_x < ((5*8)<<H_S) || E->X.s_x > ((25*8)<<H_S)) && (E->s_y > (270<<V_S))) {
						create_new_eip(E);
						delete_ennemi_in_array(E);
						if (E->X.id!=3)
						load_waiting_line(E);
						else
						E->reserved = FALSE;
						E->visible=FALSE;
						E->is_falling = FALSE;//useless (I think (but I am really not sure :s/**/
					}
		   	}
		   	E++;
		  }
		  
			
			/***********************************
	  	*
	  	*	Gestion des mouvements des fireball
	  	*
	  	***********************************/
	  	if (q.fireball_on) {
		  	if (!q.green_fireball.on && !q.mf[0].on && random(4)==0)
		  	init_green_fireball(&q.green_fireball,&(q.mf[0]),q.p.y);
				if (q.green_fireball.on)
				move_green_fireball(&q.green_fireball,&(q.mf[0]));
	  	}
	

			/***********************************
	  	*
	  	*	Gestion des mouvements des pices
	  	*
	  	***********************************/	
			COIN_STRUCT *c = coins;
			for (i=MAX_NUMBER_OF_COIN;i--;) {
				if (c[i].visible) {
					move_coin(&c[i]);
					
					
				}
				//c++;
			}
			
			
			
	
			/***********************************
	  	*
	  	*	Gestion des stalagmites
	  	*
	  	***********************************/	
			
			if (q.stalag_on) {
				STALAG_STRUCT *s = stalag;
				for (i=4;i--;) {
					if (s->animation_on)
					move_stalag(s);
					else {
						if (random(CHANCE_TO_GET_A_STALAG)==0)
						create_stalag(s);
					}
					s++;
				}		
			}
			#ifdef DEBOOOG
				FAR_AWAY:
			#endif
	
			/***********************************
	  	*
	  	*	Animation du joueur qui court ou qui saute
	  	*
	  	***********************************/				
	    if (q.p.s_y != q.p.last_frame_s_y) {
	    	q.p.step = 3;
	    }
		  else
		  {
		   	if (q.p.last_frame_s_x != q.p.s_x && q.key_was_pressed) {
					q.p.inter_step++;
					if (q.p.inter_step==INTER_STEP_NUM) {
						q.p.inter_step = 0;
						q.p.step++;
						if (q.p.step >= STEP_NUM)
						q.p.step = 0;
					}
				}
				else
				{
					q.p.step = 0;
				}
			}
	
	
	  q.time++;
		if (q.time&11) {
	
	  	/***********************************
	  	*	Affichage du fond dans un buffer
	  	***********************************/  	  

			if (controlState!=CONTROL_FF || (q.time&0b111)==0b100)
			DrawPlane(q.x_fg,q.y_fg,&fg_plane,pl,TM_GRPLC,TM_G8B);

			
		#ifdef DEBOOOG
			goto FARTHER1;
		#endif
		
	  	/***********************************
	  	*	Affichage des pices qui sortent
	  	***********************************/  	
			
			
			
			for (i=MAX_COIN_IO;i--;) {
				if (q.cop[i].time) {
					move_coin_out(&q.cop[i]);
					draw_coin_io((COORD_STRUCT*)(&q.cop[i]),q.x_fg,q.y_fg);
				}
				if (cip[i].time) {
					move_coin_in(&cip[i]);
					draw_coin_io((COORD_STRUCT*)(&cip[i]),q.x_fg,q.y_fg);
				}
			}
			
			

	  	/***********************************
	  	*	Affichage des ennemies qui sortent
	  	***********************************/  	
	  				
			for (i=MAX_ENNEMI_IO;i--;) {
				if (eop[i].time) {
					draw_ennemi_out((ENNEMI_OUT_PIPE*)(&eop[i]),q.x_fg,q.y_fg);
				}
				if (eip[i].time) {
					draw_ennemi_in((ENNEMI_IN_PIPE*)(&eip[i]),q.x_fg,q.y_fg);
				}
			}

	 		/***********************************
	  	*	Affichage des mask
	  	***********************************/  		
			draw_masked_pipes(q.x_fg,q.y_fg);			
			


		#ifdef DEBOOOG
			FARTHER1:
		#endif
			
	  	/***********************************
	  	*	Affichage des blocks dforms
	  	***********************************/  	 			
		  for (i=1;i--;) {
				if (q.an[i].time) {
					q.an[i].time--;
					reverse_some_ennemies(q.an[i].x,q.an[i].y,q.an[i].p);
					if (q.green_fireball.on)
					check_if_fireball_explodes(&q.green_fireball,&q.mf[0],q.an[i].x,q.an[i].y,q.an[i].p);
					short a = q.an[i].time >> 1;
					for (q.y=2;q.y--;) {
						for (q.x=3;q.x--;) {
							if (q.an[i].animation_on_1[q.x] | q.an[i].animation_on_2[q.x]) {
								GrayClipISprite8_RPLC_R(q.an[i].x+(q.x<<3)-q.x_fg,q.an[i].y+(q.y<<3)-q.y_fg,8,anim_index[q.an[i].animation_on_2[q.x]][a][q.x][q.y],pl,pd);
							}
						}
					}
				}
			}    
			
			#ifdef DEBOOOG
				goto FARTHER;
			#endif

	
	  	/***********************************
	  	*	Affichage de l'animation du sol qui se gele
	  	***********************************/  			
			for (i=MAX_NUMBER_OF_FREEZE_G;i--;) {
				if (freeze_g[i].on) {
					draw_frozen_ground(&(freeze_g[i]));
					fg_plane.force_update=TRUE;
				}
			}
	 
	 
			//return;//TEST 2


	 
			if (q.p.dead)  {//IF DA PLAYA IS DEAD
		  	
		  	
		  	/***********************************
		  	*	Affichage des ennemies
		  	***********************************/  
				for (i=MAX_ENNEMIES;i--;) {
					if (q.e[i].visible) {
						draw_ennemi(&(q.e[i]),q.x_fg,q.y_fg);
					}
				}

		  	/***********************************
		  	*	Affichage des green fireballz 
		  	***********************************/  
				if (q.green_fireball.on == TRUE) {
		 			draw_fireball((FIREBALL_STRUCT*)(&q.green_fireball),q.x_fg,q.y_fg);
		 		}

		  	/***********************************
		  	*	Affichage des stalag
		  	***********************************/  
				if (q.stalag_on) {
					for (i=MAX_NUMBER_OF_STALAG;i--;) {
						if (stalag[i].animation_on) {
							draw_stalag(&(stalag[i]),q.x_fg,q.y_fg);
						}
						if (q.ex_stalag[i].time) 
						draw_exploding_stalag(&(q.ex_stalag[i]),q.x_fg,q.y_fg);
					}
				}
				
					
		  	/***********************************
		  	*	Affichage des pices
		  	***********************************/  	 		
				for (i=MAX_NUMBER_OF_COIN;i--;) {
					if (coins[i].visible) {
						draw_coin(&coins[i],q.x_fg,q.y_fg);			
					}
				}
				

			}	
			else//IF DA PLAYA AINT DEAD
			{
	
				
		  	/***********************************
		  	*	Affichage des green fireballz 
		  	***********************************/  
				if (q.green_fireball.on == TRUE) {
		 			draw_fireball((FIREBALL_STRUCT*)(&q.green_fireball),q.x_fg,q.y_fg);
		 			detect_collision_with_fireball(&q.p,&q.green_fireball);
		 		}
		 		

		  	/***********************************
		  	*	Affichage des stalag
		  	***********************************/  
				if (q.stalag_on) {
					for (i=MAX_NUMBER_OF_STALAG;i--;) {
						if (stalag[i].animation_on) {
							draw_stalag(&(stalag[i]),q.x_fg,q.y_fg);
							if (stalag[i].a<30) {
								if (collide_with_small_stalag(&(stalag[i]),&q.p)) {
									init_small_explosion(&q.ex_stalag[i],&(stalag[i]));
									stalag[i].animation_on = FALSE;
								}
							}
							else
							{
								STALAG_STRUCT* s = &(stalag[i]);
								if(COLLIDE( q.p.x+4,q.p.y+3, 8,16,  s->x+1,s->y,6,(s->a>36?14:8))) {
									kill_player(&q.p);
									init_small_explosion(&q.ex_stalag[i],&(stalag[i]));
									stalag[i].animation_on = FALSE;
								}
							
							}
						}
						if (q.ex_stalag[i].time) 
						draw_exploding_stalag(&(q.ex_stalag[i]),q.x_fg,q.y_fg);
					}
				}
				
					
		  	/***********************************
		  	*	Affichage des pices
		  	***********************************/  	 		
				for (i=MAX_NUMBER_OF_COIN;i--;) {
					if (coins[i].visible) {
						detect_collision_with_coin(&q.p,&(coins[i]));
						draw_coin(&coins[i],q.x_fg,q.y_fg);			
					}
				}
				
		  	/***********************************
		  	*	Affichage des ennemies
		  	********************************** */ 
				
				for (i=MAX_ENNEMIES;i--;) {
					if (q.e[i].visible) {
						draw_ennemi(&(q.e[i]),q.x_fg,q.y_fg);
						detect_collision_with_ennemi(&q.p,&(q.e[i]));
					}
				}
			}
			

	  	/***********************************
	  	*	Affichage des anims
	  	***********************************/  		
			for (i=MAX_ANIM;i--;) {
			 	if (anim[i].time)
			 	draw_anim(&(anim[i]),q.x_fg,q.y_fg);
			 	//if (score_anim[i].time)
			 	//draw_score_anim(&(score_anim[i]),x_fg,y_fg);
			}
			
	  	/***********************************
	  	*	Affichage des ennemies en train de crever
	  	***********************************/
			for(i=MAX_DEAD_ANIM;i--;) {
				if (dead_anim[i].on)
				draw_dead_anim(&(dead_anim[i]),q.x_fg,q.y_fg);
			}
		
	  	/***********************************
	  	*	Affichage des explosions des iceman
	  	***********************************/  		
		
			
			for (i=MAX_EXPLODING_ICEMEN;i--;) {
	  		if (exploding_icemen[i].on) {
					draw_exploding_icemen(&(exploding_icemen[i]),q.x_fg,q.y_fg);			
	  		}
	  	}
			
	  	/***********************************
	  	*	Affichage des petites fireballz
	  	***********************************/  			
			for (i=2;i--;) {
	 			if (q.mf[i].on)
	 			draw_mini_fireball(&q.mf[i],q.x_fg,q.y_fg);		
	 		}
			
			
			#ifdef DEBOOOG
				FARTHER:
			#endif

			
		  /***********************************
	  	*	Affichage de mario
	  	***********************************/			
			if (q.p.re.time_down | q.p.re.block_time) {
				draw_respawn(&q.p,q.x_fg,q.y_fg);
			}
			else
			{
				draw_mario(&q.p,q.x_fg,q.y_fg);
			}

	 		/***********************************
	  	*
	  	*	Copiage du buffer vers l'cran
	  	*
	  	***********************************/ 
			if (q.show_level_num) {
				q.show_level_num--;
				draw_phase_number((LCD_WIDTH-8*8)>>1,((LCD_HEIGHT-20)>>1),q.level_num,pl,pd);
			}
			
			if (number_of_ennemies_in_level==0 || q.show_clear) {
				if  (TI89)
				GraySpriteX8_MASK((160-7*8)/2,(100-16)/2,16,clear_1,clear_2,clear_mask,clear_mask,7,pd,pl);
				else
				GraySpriteX8_MASK((240-7*8)/2,(128-16)/2,16,clear_1,clear_2,clear_mask,clear_mask,7,pd,pl);

				if (q.show_clear == 0) {
					q.show_clear = 40;
				}
				q.show_clear--;
				if (q.show_clear==1)
				q.jump_to_next_level = TRUE;
			}
			
			draw_score(q.p.score);
			
			if (readReplay) {
				GrayTile8x8_MASK_R((TI89?18:28),3,&control_sprite[controlState<<3],&control_sprite[controlState<<3],&control_mask[controlState<<3],&control_mask[controlState<<3],pl,pd);
				if ((q.time&0b1111)>7 || controlState==CONTROL_PAUSE)
				GraySpriteX8_MASK((TI89?(18-5)*8:(28-5)*8),3,8,demo_1,demo_1,demo_mask,demo_mask,4,pl,pd);
			}
			
			if (controlState!=CONTROL_FF || (q.time&0b111)==0b100) {
				FastCopyScreen_R(pl,GetPlane(LIGHT_PLANE));
				FastCopyScreen_R(pd,GetPlane(DARK_PLANE));	
			}		
			
			if (controlState==CONTROL_PAUSE) {
				while (!(_keytest(RR_ENTER)||_keytest(RR_ENTER2)) && !_keytest(RR_RIGHT) && !_keytest(RR_ESC));
				q.quit = _keytest(RR_ESC);
			}
			
		}
		else		//SI ON AFFICHE PAS, ON DTECTE LES COLLISIONS (ON ESSAIE EN TOUT CAS>>>)
		{		

			ChangeContrast();
			if (_keytest(RR_PLUS))
			OSContrastUp();
			if (_keytest(RR_MINUS))
			OSContrastDn();
			
			#ifdef DEBOOOG
				goto BOOOO;
			#endif	

			for (i=2;i--;) {
				if (q.pipes[i].time) {
					q.pipes[i].time--;
				}
				else {
					q.pipes[i].time =15;
	
					if (number_of_coin_to_init) {
						number_of_coin_to_init--;
						create_new_coin_going_out(i,q.cop);
						q.pipes[i].time =30;
					}
					else
					{
						if (q.slipice_on) {
							if ((random(6)<2)) {
								short j=0;
								while (q.e[j].reserved == TRUE) {j++;};
						  	q.e[j].sprite = ennemie_sprites[ID_SLIPICE];
						  	q.e[j].move_function_id  = ID_SLIPICE;
						  	q.e[j].visible=FALSE;
						  	q.e[j].X.must_be_reversed = FALSE;
						  	q.e[j].X.id = ID_SLIPICE;
						  	//e[j].X.s_x = 0;
						  	//e[j].s_y = 0;
						  	q.e[j].reserved = TRUE;
						  	short k=0;
						  	while (ennemi_to_be_initialized[k]!=NULL) {k++;};
						  	ennemi_to_be_initialized[k]=ennemi_to_be_initialized[0];
						  	ennemi_to_be_initialized[0] = &(q.e[j]);
						  	q.e[j].visible = FALSE;
						  	q.e[j].b = 0;
						  	q.e[j].speed = 0;
							}
						}
						empty_waiting_line(i);
					}
				}
			}
			check_all_collision();
		}

		#ifdef DEBOOOG
			BOOOO:
		#endif
		

		
	  } while(!q.quit && !q.jump_to_next_level);
  } while(!q.quit);
  
  #ifdef RECORD_MOVIE
		save_movie(movie);
		free(movie);
	#endif
  
  
  
  
  while ((_keytest(RR_ENTER)|| _keytest(RR_ENTER2)));
  if (!readReplay)
  update_score(q.p.score, q.level_num);
  return(q.quit==2);
}

//!yacas cos(x):="Tu sux"
//http://www.amiga2.free.fr/alchimie4/diapos_600/Alchimie_IV_084.jpg
//Comme un dieu
//sexy boy
// !yacas start():=[a:=Random();"f";]
//10h au macdo
//flo: 0609659491
//Je suis complemtement bourr. il est 10:43pom, et je ai une l
//
//MM: 0141813519 ou 06 32 20 74 82 ou 0870357816
//rdv a 8h15 a ampere